'MAX132 DATA LOGGER BY TERRY MILLWARD - MAXIM UK    22 JAN 1995
'PLEASE FEEL FREE TO MODIFY AND USE AS YOU LIKE

'CLS 0                                          'CLEAR SCREEN

'LPT1 OUT @ &H378, IN @ &H379
'LPT2 OUT @ &H278, IN @ &H279

'25 WAY D TYPE    

'SIGNALS TO DATA AQ CARD
'PIN 2 D0 (OUT)   POWER +
'PIN 3 D1 (OUT)   POWER +
'PIN 4 D2 (OUT)   SCLK
'PIN 5 D3 (OUT)   DATA OUT (FROM PC)
'PIN 6 D4 (OUT)   CS\
'PIN 7 D5 (OUT)   TEST STROBE -PULSE AT START OF CHANNEL SCAN

'SIGNALS FROM DATA AQ CARD
'PIN 15 D3 (IN)  DATA IN (TO PC)
'PIN 13 D4 (IN)  EOC
'PIN 12 D5 (IN)  50/60Hz SELECTION ("1" FOR 50Hz, "0" FOR 60Hz)
'PINS 18-25 ARE GROUND

DIM DIN(2, 8) AS INTEGER, DOUT(8) AS INTEGER

'INITIALISE VALUES

'COMMAND REGISTER 0
DIN(0, 0) = 0                   'FIXED
DIN(0, 1) = 0                   'RS1
DIN(0, 2) = 0                   'RS0
DIN(0, 3) = 0                   'DON'T CARE
DIN(0, 4) = 1                   'READ ZERO, 0= READ Vin
DIN(0, 5) = 0                   'AWAKE, 1=SLEEP
DIN(0, 6) = 1                   '50Hz, 0=60Hz
DIN(0, 7) = 0                   'NO CONVERT, 1=CONVERT

'COMMAND REGISTER 1
DIN(1, 0) = 1                   'FIXED
DIN(1, 1) = 0                   'DON'T CARE
DIN(1, 2) = 0                   'DON'T CARE
DIN(1, 3) = 0                   'DON'T CARE
DIN(1, 4) = 0                   'SET P0
DIN(1, 5) = 0                   'SET P1
DIN(1, 6) = 0                   'SET P2
DIN(1, 7) = 0                   'SET P3

'INTRODUCTION

PRINT "WELCOME TO THE MAX132 DATA LOGGER"
PRINT

INTRO:
PRINT "WHERE IS THE MAX132 CONNECTED? ENTER 1 FOR LPT1 OR 2 FOR LPT2"
INPUT P%
IF P% = 1 THEN PORT& = &H378                    'SET LPT1
IF P% = 2 THEN PORT& = &H278                    'SET LPT2
IF P% = 1 OR P% = 2 THEN GOTO INTRO1            'TRAP ERROR
PRINT "WRONG!!!!!! PLEASE TRY AGAIN"
GOTO INTRO

INTRO1:
IDATA& = &H13                                   'POWER ON, D0=D1=1, CS\=1
OUT PORT&, IDATA&                               'SEND DATA

PRINT
PRINT "ENTER INTERVAL BETWEEN SETS OF SAMPLES IN WHOLE SECONDS"
INPUT INTERVAL!
INTERVAL& = INT(INTERVAL!)
IF INTERVAL& = 0 THEN INTERVAL& = 1         '0 IS NOT ALLOWED
PRINT
PRINT "TIME INTERVAL IS"; INTERVAL&;
IF INTERVAL& = 1 THEN PRINT "SECOND" ELSE PRINT "SECONDS"
PRINT

INTRO2:
PRINT "HOW MANY CHANNELS DO YOU WANT TO SAMPLE? ENTER 1-->4"
PRINT
PRINT "IF 1 SELECTED CHANNEL 1 MUST BE USED, 2 SELECTED CHANNELS 1 AND 2 ETC"
INPUT NOCHANS%
IF NOCHANS% > 0 AND NOCHANS% < 5 THEN GOTO INTRO3
PRINT "WRONG!!!!!! PLEASE TRY AGAIN"
GOTO INTRO2

INTRO3:
PRINT
IF NOCHANS% = 1 THEN PRINT "CHANNEL 1 SELECTED"
IF NOCHANS% = 2 THEN PRINT "CHANNELS 1 AND 2 SELECTED"
IF NOCHANS% = 3 THEN PRINT "CHANNELS 1, 2 AND 3 SELECTED"
IF NOCHANS% = 4 THEN PRINT "CHANNELS 1, 2, 3 AND 4 SELECTED"
PRINT

INTRO4:
PRINT "DO YOU WANT TO WRITE DATA TO DISK? (Y/N)"
INPUT DISK$                                     'FLAG FOR DATA TO DISK
DISK$ = UCASE$(DISK$)                           'FORCE TO UPPER CASE
IF DISK$ = "Y" OR DISK$ = "N" THEN GOTO INTRO5
PRINT "WRONG!!!!!! PLEASE TRY AGAIN"
GOTO INTRO4

INTRO5:
IF DISK$ = "N" THEN GOTO INTRO6
PRINT
PRINT "ENTER DRIVE, PATH AND FILE NAME. EG C:\TEMP\DATA.DAT"
INPUT DATAFILE$
ON ERROR GOTO FILEERROR                         'TRY TO ESCAPE IF FILE/PATH/DISK ERROR
OPEN DATAFILE$ FOR OUTPUT AS #1

INTRO6:
PRINT
FREQ& = INP(PORT& + &H1) AND &H20               'MAINS REJECTION -> 1 50Hz, 0 60Hz

PRINT "BOARD IS SET FOR";
IF FREQ& = &H20 THEN PRINT " 50Hz";  ELSE PRINT " 60Hz";
PRINT " MAINS FREQUENCY REJECTION"
IF FREQ& = &H20 THEN DIN(0, 6) = 1 ELSE DIN(0, 6) = 0'SET 132 FOR MAINS FREQUENCY
REF& = 512                                      'REFERENCE=512mV
PRINT

INTRO7:
PRINT "PRESS Y TO START N TO ABORT "            'WAIT FOR GO"
INPUT GO$
GO$ = UCASE$(GO$)                               'FORCE TO UPPER CASE
IF GO$ = "Y" OR GO$ = "N" THEN GOTO INTRO8
PRINT "WRONG!!!!!! PLEASE TRY AGAIN"
GOTO INTRO7

INTRO8:
IF GO$ = "N" THEN GOSUB MAINEND

ON KEY(1) GOSUB MAINEND                         'F1 CLOSES ANY OPEN FILE
KEY(1) ON                                       'AND EXITS

MAIN:                                           'MAIN BIT OF PROGRAM
ON KEY(2) GOSUB RST                             'F2 RESTARTS WITH SAME SETUP
KEY(2) ON

GOSUB ZERO                                     'INITIALISE 132

'DEFINE SOME VARIABLES
DIM Y(4, 470)                                   'ARRAY TO HOLD PLOT DATA
DIM VDISP(4) AS SINGLE
DIM VPLOT(4) AS LONG                            'PLOT Y AXIS
DIM CH AS INTEGER                               'CHANNEL NUMBER
DIM COL(4) AS INTEGER                           'CHANNEL COLOURS
DIM ROW(4) AS INTEGER                           'ARRAY FOR VOLT DISPLAY ROW

'SET UP DISPLAY FOR OUTPUT
SCREEN 12                                       'VGA SCREEN
WINDOW (-170, -240)-(470, 240)                  'DEFINE WINDOW CO-ORDINATES
LINE (-5, 0)-(470, 0), 1                        'DRAW A FEW LINES
LINE (0, 220)-(0, -225), 1
LINE (0, 220)-(470, 220), 1
LINE (0, -220)-(470, -220), 1
LINE (470, 220)-(470, -220), 1
LINE (100, -220)-(100, -225), 1
LINE (200, -220)-(200, -225), 1
LINE (300, -220)-(300, -225), 1
LINE (400, -220)-(400, -225), 1
COLOR 9
LOCATE 30, 40, 0
PRINT INTERVAL& * 100; "SECS PER DIVISION";

LINE (-5, 32)-(0, 32), 1                        'Y MARKERS
LINE (-5, 64)-(0, 64), 1
LINE (-5, 96)-(0, 96), 1
LINE (-5, 128)-(0, 128), 1
LINE (-5, 160)-(0, 160), 1
LINE (-5, 192)-(0, 192), 1

LINE (-5, -32)-(0, -32), 1
LINE (-5, -64)-(0, -64), 1
LINE (-5, -96)-(0, -96), 1
LINE (-5, -128)-(0, -128), 1
LINE (-5, -160)-(0, -160), 1
LINE (-5, -192)-(0, -192), 1

LOCATE 1, 1, 0
COLOR 9
PRINT "MAX132 4 CHANNEL DATA LOGGER           F1 TO TERMINATE   F2 TO RESET"
PRINT : PRINT : PRINT : PRINT : PRINT : PRINT : PRINT
PRINT "TIME ELAPSED"

LOCATE 16, 19, O                                'LABELS FOR 50Hz
PRINT "OV"
LOCATE 3, 15, 0
PRINT "+600mV"
LOCATE 28, 15, 0
PRINT "-600mV"

COL(1) = 14                                     'CHAN 1 IS YELLOW
COL(2) = 4                                      'CHAN 2 IS RED
COL(3) = 2                                      'CHAN 3 IS GREEN
COL(4) = 3                                      'CHAN 4 IS CYAN
ROW(1) = 12: ROW(2) = 16                        'ROWS FOR VOLT DISP
ROW(3) = 20: ROW(4) = 24

'SETUP TIMER
STARTTIME& = TIMER                              'NOTE START TIME
NOWTIME& = TIMER                                'WHAT IS THE TIME?
ELAPSED& = 0                                    'SET ELAPSED TIME TO ZERO

START:                                          'START OF PLOT ROUTINE
FOR X = 1 TO 469
 NEXTTIME& = NOWTIME& + INTERVAL&               'TIME FOR NEXT SAMPLE
 IF NEXTTIME& > 86399 THEN NEXTTIME& = NEXTTIME& - 86400    'TRAP MIDNIGHT ROLLOVER
 HR& = INT(ELAPSED& / 3600)                     'WHOLE HOURS
 HR$ = LTRIM$(STR$(HR&))
 IF HR& < 10 THEN HR$ = "0" + HR$               'FIT LEADING ZERO IF <10
 REMSEC& = ELAPSED& - (HR& * 3600)              'SECS AFTER WHOLE HRS SUB'D
 MIN& = INT(REMSEC& / 60)                       'SETUP ELAPSED CLOCK
 MIN$ = LTRIM$(STR$(MIN&))
 IF MIN& < 10 THEN MIN$ = "0" + MIN$            'FIT LEADING ZERO IF <10
 SEC& = REMSEC& - (MIN& * 60)                   'SECS AFTER WHOLE MINS SUB'D
 SEC$ = LTRIM$(STR$(SEC&))
 IF SEC& < 10 THEN SEC$ = "0" + SEC$            'FIT LEADING ZERO IF <10
 
 ELTIME$ = HR$ + ":" + MIN$ + ":" + SEC$        'CREATE CLOCK

 LOCATE 10, 1, 0                                'SET CURSOR FOR TIME
 COLOR 9
 PRINT ELTIME$                                  'TIME DISPLAY

 GOSUB ZERO                                     'ALLOW INPUT TO SETTLE
 GOSUB ZERO                                     'FIND VZERO

 IDATA& = IDATA& OR &H20                        'TEST STROBE SET TO 1
 OUT PORT&, IDATA&                              'SEND DATA
 IDATA& = IDATA& AND &HDF                       'TEST STROBE SET TO 0
 OUT PORT&, IDATA&                              'SEND DATA
 
 IF DISK$ = "Y" THEN PRINT #1, ELTIME$;         'PRINT TIME TO DISK HERE
 FOR CH = 1 TO NOCHANS%
  GOSUB SETCH                                   'SET CHANNEL
  GOSUB VIN                                     'ALLOW INPUT  TO SETTLE
  GOSUB VIN                                     'READ INPUT
  VPLOT(CH) = (VIN& - VZERO&) / 200             'SCALE 132 OUTPUT
  VDISP(CH) = REF& * (VIN& - VZERO&) / 32768    'SCALE 132 O/P FOR mV
  PSET (X, Y(CH, X)), 0                         'RESET BACKGROUND
  IF Y(CH, X) = 0 THEN PSET (X, Y(CH, X)), 1    'CATCH CENTRE LINE
  Y(CH, X) = VPLOT(CH)
  PSET (X, Y(CH, X)), COL(CH)                   'SET NEW VALUE
  LOCATE ROW(CH), 1, 0                          'SET CURSOR FOR DIGITS
  COLOR COL(CH)
  PRINT CH; " ";
  PRINT USING "+###.##"; VDISP(CH);
  PRINT "mV  "
  IF ABS(VIN&) > 34880 THEN PRINT "    SOFT OVERRANGE" ELSE PRINT "                  "
  IF DISK$ = "Y" THEN PRINT #1, USING " +###.##"; VDISP(CH);  'DATA TO DISK
 NEXT CH
 IF DISK$ = "Y" THEN PRINT #1,                   'CR FOR DATA TO DISK

HOLD:
 NOWTIME& = TIMER
 IF NOWTIME& < NEXTTIME& THEN GOTO HOLD
 ELAPSED& = ELAPSED& + INTERVAL&                'TIME OF NEXT SCAN
NEXT X
GOTO START                                      'END OF SCREEN

MAINEND:                                        'ESCAPE ROUTINE IF F1 PRESSED
IF DISK$ = "Y" THEN CLOSE #1
IDATA& = &H0                                    'POWER OFF
OUT PORT&, IDATA&
GOTO FINISH
RETURN                                          'NEVER GETS HERE

RST:                                            'RESET IF F2 PRESSED
IF DISK$ = "Y" THEN CLOSE #1
IF DISK$ = "Y" THEN OPEN DATAFILE$ FOR OUTPUT AS #1
CLS 0
GOTO MAIN
RETURN                                          'NEVER GETS HERE

FILEERROR:                                      'ERROR WHEN ENTERING FILE NAME
PRINT
PRINT "ERROR ASSOSIATED WITH:"
PRINT
PRINT "1. NON EXISTANT DISK OR DISK NOT IN DRIVE"
PRINT "2. BAD PATHNAME OR NON-EXISTANT PATH"
PRINT "3. ILLEGAL FILENAME"
PRINT
PRINT " PROGRAM ABORTED. FIND PROBLEM AND RESTART"
GOTO MAINEND

ZERO:                                           'MEASURE 132 ZERO
DIN(0, 4) = 1                                   'READ ZERO
GOSUB READING
VZERO& = READING&
RETURN

VIN:                                            'MEASURE INPUT VOLTS
DIN(0, 4) = 0                                   'READ INPUT
GOSUB READING
VIN& = READING&
RETURN
  
READING:                                        'READ DATA FROM 132
DIN(0, 1) = 0                                   'RS0, RS1
DIN(0, 2) = 0                                   'SET UP FOR B3-B10 NEXT TIME
DIN(0, 7) = 1                                   'START CONVERT
REG% = 0                                        'COM REG 0
GOSUB IO                                        'SEND DATA
DIN(0, 7) = 0                                   'NO CONVERT

WAIT (PORT& + &H1), &H10                        'WAIT FOR EOC FROM 132

DIN(0, 1) = 0                                   'RS0, RS1
DIN(0, 2) = 1                                   'SET UP FOR B11-B18 NEXT TIME
GOSUB IO                                        'SEND DATA
LSB& = ODATA&                                   'LSB FROM 132

DIN(0, 1) = 1                                   'RS0, RS1
DIN(0, 2) = 0                                   'SET UP FOR STATUS NEXT TIME
GOSUB IO                                        'SEND DATA
MSB& = ODATA&                                   'MSB FROM 132, 2'S COMP

DIN(0, 1) = 1                                   'RS0, RS1
DIN(0, 2) = 0                                   'SET UP FOR STATUS NEXT TIME
GOSUB IO                                        'SEND DATA
STATUS& = ODATA&                                'STATUS FROM 132
SPOL& = (STATUS& AND &H8)                       'POLARITY, &H8 IS -VE

READING& = (&H100 * MSB& + LSB&)
IF SPOL& = &H8 GOTO TWOCOMP                     'IS NUMBER NEGATIVE
RETURN

TWOCOMP:                                        'SORT OUT NEG NUMBER
READING& = (&H100 * MSB& + LSB&) - &H10000
RETURN

SETCH:                                          'SETS CHANNEL
REG% = 1                                        'SET COMM REG 1
IF CH = 2 OR CH = 4 THEN DIN(1, 4) = 1 ELSE DIN(1, 4) = 0       'P0
IF CH = 3 OR CH = 4 THEN DIN(1, 5) = 1 ELSE DIN(1, 5) = 0       'P1
GOSUB IO
RETURN
       
IO:                                             'DATA I/O ROUTINE
                                                'REG% IS REGISTER, 0/1
ODATA& = &H0
IDATA& = IDATA& AND &HEF                        'CS\ SET TO 0
OUT PORT&, IDATA&
FOR SHIFT = 7 TO 0 STEP -1
 DOUT(SHIFT) = (INP(PORT& + &H1) AND &H8)       'GET DATA FROM 132
 ODATA& = ODATA& + DOUT(SHIFT) * 2 ^ (SHIFT - 3)'COMPILE DATA
 IDATA& = IDATA& OR ((DIN(REG%, SHIFT) * 8))    'DATA TO GO TO 132
 OUT PORT&, IDATA&
 IDATA& = IDATA& OR &H4                         'SCLK TO 1
 OUT PORT&, IDATA&
 IDATA& = IDATA& AND &HF3                       'DATA BIT BACK TO 0, SCLK TO
 OUT PORT&, IDATA&
NEXT SHIFT
IDATA& = IDATA& OR &H10                         'CS\ SET TO 1
OUT PORT&, IDATA&

RETURN

FINISH:

END

